const Mesa = require('vendor/Mesa.js');

/**
 * A Mesa Script exports a class with a script() method.
 */
module.exports = new class {

  /**
   * Mesa Script
   *
   * @param {object} payload The payload data
   * @param {object} context Additional context about this task
   */
  script = (payload, context) => {
    let options = {
      "headers": {
        "Content-Type": "application\/json",
        "Authorization": "Bearer " + Mesa.credential.get('airtable'),
      }
    }

    let base = context.steps.transform.base;
    let table = context.steps.transform.table;
    let primaryKey = context.steps.transform.primary_key;
    let primaryKeyValue = context.steps.transform.primary_key_value;
    let filterByFormula = `{${primaryKey}} = '${primaryKeyValue}'`;
    let url = 'https://api.airtable.com/v0/' + base + '/' + table + '?filterByFormula=' + encodeURIComponent(filterByFormula);

    let results = Mesa.request.get(url, options);    
    Mesa.log.info("results", results);

    if (results.records.length > 0) {
      Mesa.output.next(results.records[0]);
      return;
    } 

    url = 'https://api.airtable.com/v0/' + base + '/' + table;

    let data = {
      "records": [
        {
          "fields": {            
          }
        }
      ],
      "typecast": true,
    }
    data.records[0].fields[primaryKey] = primaryKeyValue;

    let result = Mesa.request.post(url, data, options);
    let record = result.records[0];

    Mesa.output.next(record);
  }
}